/*-----------------------------------------------------------------------------
Modul Name : Agentsock.h
Date       : 30.10.97
-------------------------------------------------------------------------------
Author     : Klaus Dorer

Description: Socket class for Soccerserver communication

Comments   : _
-----------------------------------------------------------------------------*/
#ifndef __AGENTSOCK_H__
#define __AGENTSOCK_H__


/*-----------------------------------------------------------------------------
Class   : CAgentSocket
Date    : 30.10.97
-------------------------------------------------------------------------------
Base Class: CAsyncSocket

Description: because the port of a player changes when receiving the first 
				 messages from the server, CAsyncSocket could not be used as it was
				 but had to be changed in the methods listed here
-----------------------------------------------------------------------------*/
class CAgentSocket : public CAsyncSocket
{
	DECLARE_DYNAMIC(CAgentSocket);

	public:
		CAgentSocket();
		
		// functions from CAsyncsocket adapted for this use
		BOOL Create(UINT nSocketPort, LPCTSTR lpszSocketAddress);
		BOOL Bind(UINT nSocketPort, LPCTSTR lpszSocketAddress);
		BOOL Connect(LPCTSTR lpszHostAddress, UINT nHostPort);
		int  ReceiveFrom(void* lpBuf, int nBufLen, CString& rSocketAddress, UINT& rSocketPort
								, int nFlags);
		int  SendTo(const void* lpBuf, int nBufLen, UINT nHostPort, LPCTSTR lpszHostAddress
								, int nFlags);
		
		// get and set functions
		void			SetPort(UINT port) { m_uiPort = port; };
		UINT			GetPort(void) { return m_uiPort; };
		CString		GetAddress(void) { return m_sSocketAddress; };

	protected:
		// notification functions
		virtual void OnReceive(int nErrorCode);

	private:
		SOCKADDR_IN		sockAddr;
		UINT				m_uiPort;
		CString			m_sSocketAddress;
};

#endif // __AGENTSOCK_H__
