// Basis.h : main header file for the BASIS application
//

#if !defined(AFX_BASIS_H__54CD01C9_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_BASIS_H__54CD01C9_4540_11D1_B242_0000C09B5CBE__INCLUDED_

#ifdef WINDOWS95

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#define COLOR_MYTEAM RGB(200, 200, 20)			// yellow
#define COLOR_OTHERTEAM RGB(200, 20, 20)		//	red
#define COLOR_AGENT RGB(20, 200, 20)			// green
#define COLOR_BALL RGB(20, 20, 200)				// blue
#define COLOR_GOAL RGB(0, 0, 0)					// black
#define COLOR_FLAG RGB(200, 200, 200)			// light gray
#define COLOR_LINE RGB(255, 255, 255)			// white
#define COLOR_ANY_OBJECT RGB(40, 40, 40)		// dark gray
#define COLOR_FIELD RGB(20, 150, 20)			// green
#define COLOR_VISIBLE_AREA RGB(20, 130, 20)	// green, a little lighter than above
#define COLOR_SKY RGB(30, 30, 150);				// light blue

#endif //WINDOWS95

#define DIS_VERSION	1					// version info for serialization
#define PI				3.1415926		// pi
#define D_ZERO_P		0.0000001
#define D_ZERO_N		-0.0000001

#define NEWLINE "\r\n";
#define STRING_IF "If"
#define STRING_AND "and"
#define STRING_THEN "Then"
#define STRING_EFFECT "Effect"
#define STRING_NOT "not"
#define STRING_END_IF "endif"

#define MY_TEAM "Team1"			// name of my team
#define DEFAULT_SERVER "ultra2"
#define DEFAULT_CHANNEL	6000	// socket channel
#define DEFAULT_MASTERCH 6001	// channel for master mode

#define LEFT_TO_RIGHT	0
#define RIGHT_TO_LEFT	1

#define MAX_PLAYERS 22				// maximum number of players
#define MAX_PERCEPTION_LEN 1024	// maximum length of perception message
#define MAX_SAY_LEN					// maximum length of a say statement

#define NOT_EXISTING -32000	// items not existing in a perception

// playmodes (Left are always odd numbers)
#define BEFORE_KICK_OFF		0
#define KICK_OFF_L			1
#define KICK_OFF_R			2
#define KICK_IN_L				3
#define KICK_IN_R				4
#define CORNER_KICK_L		5
#define CORNER_KICK_R		6
#define GOAL_KICK_L			7
#define GOAL_KICK_R			8
#define FREE_KICK_L			9
#define FREE_KICK_R			10
#define PLAY_ON				20
#define HALF_TIME				21
#define TIME_UP				22
#define EXTEND					23
#define FOUL_L					50
#define FOUL_R					60
#define GOAL_L					100
#define GOAL_R					200


#define FIELD_FLAG			1
#define PENALTY_AREA_FLAG	2

// for visualizing
#define PLAYERSIZE	6			// radius of the circle representing the player
#define BALLSIZE		4
#define FLAG_SIZE		3

#define MODULE_SIZE 5.0

#define NO_OF_PLAYMODES		17
#define PLAYMODE_STRINGS {"",\
			"before_kick_off",\
			"time_over",\
			"play_on",\
			"kick_off_l",\
			"kick_off_r",\
			"kick_in_l",\
			"kick_in_r",\
			"free_kick_l",\
			"free_kick_r",\
			"corner_kick_l",\
			"corner_kick_r",\
			"goal_kick_l",\
			"goal_kick_r",\
			"goal_l",\
			"goal_r",\
			"drop_ball"}

typedef enum _PlayMode {
     PM_Null,
     PM_BeforeKickOff,
	 PM_TimeOver,
     PM_PlayOn,
     PM_KickOff_Left,
     PM_KickOff_Right,
     PM_KickIn_Left,
     PM_KickIn_Right,
	 PM_FreeKick_Left,
	 PM_FreeKick_Right,
	 PM_CornerKick_Left,
	 PM_CornerKick_Right,
	 PM_GoalKick_Left,
	 PM_GoalKick_Right,
	 PM_AfterGoal_Left,
	 PM_AfterGoal_Right,
	 PM_Drop_Ball,
     PM_MAX 
} PlayMode ;

#ifdef WINDOWS95

/////////////////////////////////////////////////////////////////////////////
// CBasisApp:
// See Basis.cpp for the implementation of this class
//

class CBasisApp : public CWinApp
{
public:
	CBasisApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasisApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CBasisApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //WINDOWS95

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BASIS_H__54CD01C9_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
