// BasisDoc.h : interface of the CBasisDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASISDOC_H__54CD01CF_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_BASISDOC_H__54CD01CF_4540_11D1_B242_0000C09B5CBE__INCLUDED_

#ifdef WINDOWS95

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TViewingAgent;
class CBaseAgent;

class TPerceptionView;
class TKnowledgeView;
class CBasisView;
class TNetworkView;

/*-----------------------------------------------------------------------------
Class   : CBasisDoc
Date    : 14.11.97
-------------------------------------------------------------------------------
Base Class: CDocument

Description: _
-----------------------------------------------------------------------------*/
class CBasisDoc : public CDocument
{
protected: // create from serialization only
	CBasisDoc();
	DECLARE_DYNCREATE(CBasisDoc)

// Attributes
public:

private:
	TViewingAgent*	m_pAgent;
	CBaseAgent*		m_pGhost[11];		// only for testing

	TPerceptionView*	m_pPerceptionView;
	TKnowledgeView*	m_pKnowledgeView;
	CBasisView*			m_pBasisView;
	TNetworkView*		m_pNetworkView;
	BOOL					m_bNoGraphics;

	BOOL				m_bConnected;
	BOOL				m_bTryingToConnect;


// Operations
public:

	TViewingAgent*	GetAgent(void) { return m_pAgent; };

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBasisDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBasisDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBasisDoc)
	afx_msg void OnGhostteam();
	afx_msg void OnGhostdistribute();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnUpdateDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateConnect(CCmdUI* pCmdUI);
	afx_msg void OnViewNographics();
	afx_msg void OnUpdateViewNographics(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif //WINDOWS95

#endif // !defined(AFX_BASISDOC_H__54CD01CF_4540_11D1_B242_0000C09B5CBE__INCLUDED_)
