#if !defined(AFX_TPERCEPTIONVIEW_H__C955DB41_7793_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TPERCEPTIONVIEW_H__C955DB41_7793_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TPerceptionView.h : header file
//

class TScreenParams;
class TPerception;

/*-----------------------------------------------------------------------------
Class   : TPerceptionView
Date    : 18.12.97
-------------------------------------------------------------------------------
Base Class: CView

Description: View on the players perceptions
-----------------------------------------------------------------------------*/
class TPerceptionView : public CView
{
protected:
	TPerceptionView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(TPerceptionView)

// Attributes
public:

	CString			m_Msg[12000];
	int				m_iNoOfCycles;
	int				m_iCurrentCycle;
	CString			m_strFileName;
	BOOL				m_bRunning;
	BOOL				m_bChanged;
	int				m_iTimerID;
	BOOL				m_bNoGraphics;

	TScreenParams*	m_pScreen;
	TPerception*	m_pPerception;
	
// Operations
public:

	void	NewMessage(LPCTSTR msg);
	void	DrawCurrentCycle();
	void	LoadFromArchive(CArchive &archive);
	void	SaveToArchive(CArchive &archive);
	void	SetPerception(TPerception* pPercept) {m_pPerception = pPercept; };
	void	SetNoGraphics(BOOL val) { m_bNoGraphics = val; };
	void	RedrawView();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TPerceptionView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~TPerceptionView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(TPerceptionView)
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnZoomPlus();
	afx_msg void OnViewPlayersView();
	afx_msg void OnUpdateViewPlayersView(CCmdUI* pCmdUI);
	afx_msg void OnZoomMinus();
	afx_msg void OnViewAngle();
	afx_msg void OnViewQuality();
	afx_msg void OnUpdateViewQuality(CCmdUI* pCmdUI);
	afx_msg void OnLogPerceptBack();
	afx_msg void OnLogPerceptGoto();
	afx_msg void OnLogPerceptOneStep();
	afx_msg void OnLogPerceptPlay();
	afx_msg void OnUpdateLogPerceptBack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLogPerceptGoto(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLogPerceptOneStep(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLogPerceptPlay(CCmdUI* pCmdUI);
	afx_msg void OnFileSavePerception();
	afx_msg void OnFileOpenPerception();
	afx_msg void OnUpdateFileOpenPerception(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSavePerception(CCmdUI* pCmdUI);
	afx_msg void OnFileSaveAsPerception();
	afx_msg void OnUpdateFileSaveAsPerception(CCmdUI* pCmdUI);
	afx_msg void OnLogPerceptStop();
	afx_msg void OnUpdateLogPerceptStop(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCommands();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TPERCEPTIONVIEW_H__C955DB41_7793_11D1_B242_0000C09B5CBE__INCLUDED_)
