// TScreenParams.h: interface for the TScreenParams class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#define DEFAULT_MIDX 300
#define DEFAULT_MIDY 100
#define DEFAULT_SCALEX 1.0
#define DEFAULT_SCALEY 3.0

/*-----------------------------------------------------------------------------
Class   : TScreenParams
Date    : 15.05.96
-------------------------------------------------------------------------------
Base Class: CObject

Description: controls the screen sccaling and translation
-----------------------------------------------------------------------------*/
class TScreenParams : public CObject  
{
	public:
		TScreenParams();
		virtual ~TScreenParams();

		int		GetMitteX(void) { return m_tMiddle.x; };
		int		GetMitteY(void) { return m_tMiddle.y; };
		double	GetScale(void) { return m_dScale; };
		void		SetScale(double scale) { m_dScale = scale; };
		void		SetSize(CSize size) { m_tSize = size; };
		CSize		GetSize() const { return m_tSize; };

		void		SetParams(int sizex, int sizey, double scalex);
		void		SetMid(int x, int y) { m_tMiddle.x = x; m_tMiddle.y = y; };
		void		Scale(double factor) { m_dScale *= factor; };

		void		SetTopView(BOOL bTopView = TRUE) { m_bTopView = bTopView; };
		BOOL		IsTopView() { return m_bTopView; };
		void		SetDrawNames(BOOL val) { m_bDrawNames = val; };
		BOOL		GetDrawNames(void) const { return m_bDrawNames; };

		void		SetTranslation(CPoint point) { m_tTranslate = point; };
		void		Translate(CPoint point) { m_tTranslate += point; };
		CPoint	GetTranslation() { return m_tTranslate; };

	private:
		double	m_dScale;
		CSize		m_tSize;
		CPoint	m_tTranslate;
		CPoint	m_tMiddle;

		BOOL		m_bTopView;		// for TPerception
		BOOL		m_bDrawNames;	// for TNetworkView
};

#endif // !defined(AFX_TSCREENPARAMS_H__89781B21_5CDE_11D1_B242_0000C09B5CBE__INCLUDED_)
