// TViewingAgent.h: interface for the TViewingAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TVIEWINGAGENT_H__0F8D1D81_762C_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TVIEWINGAGENT_H__0F8D1D81_762C_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "BaseAgent.h"

class TPerception;
class TScreenParams;
class CBasisView;
class	TPerceptionView;

/*-----------------------------------------------------------------------------
Class   : TViewingAgent
Date    : 15.12.97
-------------------------------------------------------------------------------
Base Class: TBaseAgent

Description: extends the base agents capabilities to perception
-----------------------------------------------------------------------------*/
class TViewingAgent : public CBaseAgent  
{
	public:
		TViewingAgent();
		TViewingAgent(CBasisView* pBView, TPerceptionView* pPView);
		virtual ~TViewingAgent();

		// normal methods
		BOOL	Connect(void);
		void	SwitchViewAngle(void); 
		void	SwitchViewQuality(void);

		// some more complex actions
		void ComplexDash(int iPower, int iDirection);
		void ComplexKick(int iPower, int iDirection);
		
		
		// attribute functions
		TPerception*	GetPerception() { return m_pPerception; };

		// overridables
		virtual void OnSentMessage(LPCTSTR message);
		virtual void OnReceivedMessage(LPCTSTR message);
		
//		virtual void OnErrorCreatingSocket() {};
//		virtual void OnErrorSendingMessage() {};
//		virtual void OnErrorReceivingMessage() {};

		virtual void OnChangedView(int mode, int quality);
		
	protected:
		TPerception*	m_pPerception; // perception class of the agent
		CBasisView*		m_pView;			// view to display network traffic
};

#endif // !defined(AFX_TVIEWINGAGENT_H__0F8D1D81_762C_11D1_B242_0000C09B5CBE__INCLUDED_)
