// TCoachAgent.h: interface for the TCoachAgent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TCOACHAGENT_H__C9352BF5_8902_11D1_B242_0000C09B5CBE__INCLUDED_)
#define AFX_TCOACHAGENT_H__C9352BF5_8902_11D1_B242_0000C09B5CBE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TBaseAgent.h"


typedef enum _PlayMode {
		PM_Null,
		PM_BeforeKickOff,
		PM_TimeOver,
		PM_PlayOn,
		PM_KickOff_Left,
		PM_KickOff_Right,
		PM_KickIn_Left,
		PM_KickIn_Right,
		PM_FreeKick_Left,
		PM_FreeKick_Right,
		PM_CornerKick_Left,
		PM_CornerKick_Right,
		PM_GoalKick_Left,
		PM_GoalKick_Right,
		PM_AfterGoal_Left,
		PM_AfterGoal_Right,
		PM_Drop_Ball,
		PM_MAX 
} PlayMode ;

class CSoccerCoachDoc;

/*-----------------------------------------------------------------------------
Class   : TCoachAgent
Date    : 09.01.98
-------------------------------------------------------------------------------
Base Class: CBaseAgent

Description: extends the base agent class to be a coach
-----------------------------------------------------------------------------*/
class TCoachAgent : public TBaseAgent  
{
	public:
		TCoachAgent(CSoccerCoachDoc*	pDoc);
		virtual ~TCoachAgent();

		// overridables
		void  Connect();
		virtual void OnCreatedSocket();
		virtual void OnReceivedMessage(LPCTSTR message);


		// methods
		void	DoCoaching();
		void	SetPlayOn();

		// basic methods
		void	ChangeMode(int mode);
		void	CoachMove(LPCTSTR objname, int x, int y, int vdir);
		void	Look();
		void	CheckBall();
		void	Ear(BOOL on);

	private:

		CSoccerCoachDoc*	m_pDoc;
		BOOL					m_bGoal;
		BOOL					m_bOutOfField;
};

#endif // !defined(AFX_TCOACHAGENT_H__C9352BF5_8902_11D1_B242_0000C09B5CBE__INCLUDED_)
