/* -*- Mode: C -*-
 *Header:
 *File: field.C
 *Author: Noda Itsuki
 *Date: 1996/02/14
 *EndHeader:
 */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <iostream.h>
#include <strstrea.h>
#include <winsock2.h>
#include "param.h"
#include "types.h"
#include "utility.h"
#include "object.h"
#include "field.h"
//#include <sys/timeb.h>
//#define _MT
#include <process.h>
#include <conio.h>

int sleepTime;
int iStop=0;

void T_DoIt(void *pParam)
{
	HANDLE	phEvent = pParam ;

	while (iStop == 0) 
	{
		Sleep( sleepTime );
		SetEvent( phEvent );
	}
	_endthread();

}


/*
 *===================================================================
 *Part: Create Stadium Window
 *===================================================================
 */
void Stadium::init(int argc, char *argv[])
{
	GetOption(argc, argv) ;

	if (logfile[0] != NULLCHAR) {
		if ((log_fp = fopen(logfile, "w")) == NULL)
			cerr << "can't open log_file " << logfile << endl ;
	}

	if (recfile[0] != NULLCHAR) 
		OpenForWrite() ;

	weather.init(this) ;
	assign() ;
	assignBall() ;
	set_ball(PVector(0.0,0.0),LEFT) ;
 	this->startp = FALSE ;
	caught_ball = FALSE ;
	player = new Player*[MAX_PLAYER * 2] ;
	olcoach = new OnlineCoach*[3] ;

	initPlayer() ;
	initCoach(this) ;
	initOnlineCoach(this) ;
	last_touch = player[0];
	time = 0 ;
	top.next = NULL ;

	change_play_mode(PM_BeforeKickOff) ;

	int i ;
	for ( i = 0 ; i <= MAX_PLAYER * 2; i++)
		socketfd[i] = -1 ;
	for ( i = 0 ; i <= MAX_PLAYER * 2; i++)
		dinfo.body.show.pos[i].enable = htons(FALSE) ;
	dinfo.mode = htons(SHOW_MODE) ;
	dinfo.body.show.team[0].name[0] = NULLCHAR ;
	dinfo.body.show.team[1].name[0] = NULLCHAR ;
	dinfo.body.show.time = htons((unsigned short)-1) ;
	minfo.mode = htons(MSG_MODE) ;

	randomize() ;

	WORD wVersionRequested;
	WSADATA wsaData;
	int err;
 
	wVersionRequested = MAKEWORD( 2, 0 );
 
	err = WSAStartup( wVersionRequested, &wsaData );
	
	udp_init(0, portnum) ;
}

void Stadium::GetOption(int argc, char **argv)
{
	option_t opt[] = {
		{"goal_width",		(void *)&gwidth,		VV_DOUBLE},
		{"player_size",		(void *)&psize,			VV_DOUBLE},
		{"player_decay",	(void *)&pdecay,		VV_DOUBLE},
		{"player_rand",		(void *)&prand,			VV_DOUBLE},
		{"player_weight",	(void *)&pweight,		VV_DOUBLE},
		{"player_speed_max",(void *)&pspeed_max,	VV_DOUBLE},
		{"stamina_max",		(void *)&stamina_max,	VV_DOUBLE},
		{"stamina_inc_max",	(void *)&stamina_inc,	VV_DOUBLE},
		{"recover_dec_thr",	(void *)&recover_dthr,	VV_DOUBLE},
		{"recover_min",		(void *)&recover_min, 	VV_DOUBLE},
		{"recover_dec",		(void *)&recover_dec, 	VV_DOUBLE},
		{"effort_dec_thr",	(void *)&effort_dthr,	VV_DOUBLE},
		{"effort_min",		(void *)&effort_min,	VV_DOUBLE},
		{"effort_dec",		(void *)&effort_dec,	VV_DOUBLE},
		{"effort_inc_thr",	(void *)&effort_ithr,	VV_DOUBLE},
		{"effort_inc",		(void *)&effort_inc,	VV_DOUBLE},
		{"ball_size",		(void *)&bsize,			VV_DOUBLE},
		{"ball_decay",		(void *)&bdecay,		VV_DOUBLE},
		{"ball_rand",		(void *)&brand,			VV_DOUBLE},
		{"ball_weight",		(void *)&bweight,		VV_DOUBLE},
		{"ball_speed_max",	(void *)&bspeed_max,	VV_DOUBLE},
		{"dash_power_rate",	(void *)&dprate,		VV_DOUBLE},
		{"kick_power_rate",	(void *)&kprate,		VV_DOUBLE},
		{"kickable_margin",	(void *)&kmargin,		VV_DOUBLE},
		{"control_radius",	(void *)&ctlradius,		VV_DOUBLE},
		{"catch_probability",
							(void *)&catch_prob,	VV_DOUBLE},
		{"catchable_area_l",(void *)&catch_area_l,	VV_DOUBLE},
		{"catchable_area_w",(void *)&catch_area_w,	VV_DOUBLE},
		{"wind_dir",		(void *)&windir,		VV_DOUBLE},
		{"maxpower",		(void *)&maxp,			VV_DOUBLE},
		{"minpower",		(void *)&minp,			VV_DOUBLE},
		{"maxmoment",		(void *)&maxm,			VV_DOUBLE},
		{"minmoment",		(void *)&minm,			VV_DOUBLE},
		{"maxneckmoment",	(void *)&maxnm,			VV_DOUBLE},
		{"minneckmoment",	(void *)&minnm,			VV_DOUBLE},
		{"maxneckang",		(void *)&maxn,			VV_DOUBLE},
		{"minneckang",		(void *)&minn,			VV_DOUBLE},
		{"visible_angle",	(void *)&visangle,		VV_DOUBLE},
		{"visible_distance",(void *)&visdist,		VV_DOUBLE},
		{"audio_cut_dist",	(void *)&audio_dist,	VV_DOUBLE},
		{"quantize_step",	(void *)&dist_qstep,	VV_DOUBLE},
		{"quantize_step_l",	(void *)&land_qstep,	VV_DOUBLE},
		{"ckick_margin",	(void *)&ckmargin,		VV_DOUBLE},
		{"wind_dir",		(void *)&windir,		VV_DOUBLE},
		{"wind_force",		(void *)&winforce,		VV_DOUBLE},
		{"wind_rand",		(void *)&winrand,		VV_DOUBLE},
		{"inertia_moment",	(void *)&inertia_moment,VV_DOUBLE},
		{"wind_none",		(void *)&win_no,		VV_BOOL},
		{"wind_random",		(void *)&win_random,	VV_BOOL},
		{"half_time",		(void *)&half_time,		VV_INT},
		{"port",			(void *)&portnum,		VV_INT},
		{"coach_port",		(void *)&coach_pnum,	VV_INT},
		{"olcoach_port",	(void *)&olcoach_pnum,	VV_INT},
		{"say_coach_cnt_max",	(void *)&say_cnt_max,	VV_INT},
		{"say_coach_msg_size",	(void *)&SayCoachMsgSize,	VV_INT},
		{"simulator_step",	(void *)&sim_st,		VV_INT},
		{"send_step",		(void *)&send_st,		VV_INT},
		{"recv_step",		(void *)&recv_st,		VV_INT},
		{"sense_body_step",	(void *)&sb_step,	VV_INT},
		{"say_msg_size",	(void *)&SayMsgSize,	VV_INT},
		{"hear_max",		(void *)&hear_max,		VV_INT},
		{"hear_inc",		(void *)&hear_inc,		VV_INT},
		{"hear_decay",		(void *)&hear_decay,	VV_INT},
		{"catch_ban_cycle", (void *)&cban_cycle,	VV_INT},
		{"coach",			(void *)&CoachMode,		VV_BOOL},
		{"coach_w_referee",	(void *)&CwRMode,		VV_BOOL},
		{"old_coach_hear",	(void *)&old_hear,		VV_BOOL},
		{"send_vi_step",        (void *)&sv_st,		VV_INT},
		{"use_offside",		(void *)&useoffside,	VV_ONOFF},
		{"offside_active_area_size",
							(void *)&offside_area,	VV_DOUBLE},
		{"forbid_kick_off_offside",
							(void *)&kickoffoffside,VV_ONOFF},
		{"log_file",		(void *)&logfile,		VV_STRING},
		{"record",			(void *)&recfile,		VV_STRING},
		{"record_version",	(void *)&rec_ver,		VV_INT},
		{"record_log",		(void *)&rec_log,		VV_ONOFF},
		{"record_messages",	(void *)&rec_msg_mode,	VV_ONOFF},
		{"send_log",		(void *)&send_log,		VV_ONOFF},
		{"verbose",			(void *)&verbose,		VV_ONOFF},
		{"replay",			(void *)&replay,		VV_STRING},
		{"offside_kick_margin",
				(void *)&offside_kick_margin,		VV_DOUBLE},
		{"\0",				NULL, 					0}
	} ;

	/* set default parameter */
	gwidth = GOAL_WIDTH ;
	psize = PLAYER_SIZE ;
	pdecay = PLAYER_DECAY ;
	prand = PLAYER_RAND ;
	pweight = PLAYER_WEIGHT ;
	stamina_max = STAMINA_MAX ;
	stamina_inc = STAMINA_INC_MAX ;
	recover_dthr = RECOVERY_DEC_THR ;
	recover_min = RECOVERY_MIN ;
	recover_dec = RECOVERY_DEC ;
	effort_dthr = EFFORT_DEC_THR ;
	effort_min = EFFORT_MIN ;
	effort_dec = EFFORT_DEC ;
	effort_ithr = EFFORT_INC_THR ;
	effort_inc= EFFORT_INC ;
	inertia_moment = IMPARAM ;
	bsize = BALL_SIZE ;
	bdecay = BALL_DECAY ;
	brand = BALL_RAND ;
	bweight = BALL_WEIGHT ;
	bspeed_max = BALL_SPEED_MAX ;
	pspeed_max = PLAYER_SPEED_MAX ;
	dprate = POWERRATE ;
	kprate = POWERRATE ;
	kmargin = KICKABLE_MARGIN ;
	ctlradius = CONTROL_RADIUS ;
	ckmargin = CORNER_KICK_MARGIN ;
	catch_prob = GOALIE_CATCHABLE_POSSIBILITY ;
	catch_area_l = GOALIE_CATCHABLE_AREA_LENGTH ; 
	catch_area_w = GOALIE_CATCHABLE_AREA_WIDTH ; 
	maxp = MAXPOWER ;
	minp = MINPOWER ;
	maxm = MAXMOMENT ;
	minm = MINMOMENT ;
	maxnm = MAX_NECK_MOMENT ;
	minnm = MIN_NECK_MOMENT ;
	maxn = MAX_NECK_ANGLE ;
	minn = MIN_NECK_ANGLE ;
	visangle = VisibleAngle ;
	visdist = VisibleDistance ;
	half_time = HALF_TIME ;
	portnum = DEFAULT_PORT_NUMBER ;
	coach_pnum = COACH_PORT_NUMBER ;
	olcoach_pnum = OLCOACH_PORT_NUMBER ;
	say_cnt_max = DEF_SAY_COACH_CNT_MAX ;
	SayCoachMsgSize = DEF_SAY_COACH_MSG_SIZE ;
	sim_st = SIMULATOR_STEP_INTERVAL_MSEC ;
	send_st = UDP_SEND_STEP_INTERVAL_MSEC ;
	recv_st = UDP_RECV_STEP_INTERVAL_MSEC ;
	sb_step = SENSE_BODY_INTERVAL_MSEC ;
	SayMsgSize = DEF_SAY_MSG_SIZE ;
	CoachMode = FALSE ;
	CwRMode = FALSE ;
	old_hear = FALSE ;
	sv_st = SEND_VISUALINFO_INTERVAL_MSEC ;
	logfile[0] = NULLCHAR ;
	recfile[0] = NULLCHAR ;
	rec_ver = DEFAULT_REC_VERSION ;
	rec_log = FALSE ;
	rec_msg_mode = TRUE ;
	replay[0] = NULLCHAR ;
	audio_dist = AUDIO_CUT_OFF_DIST ;
	hear_max = HEAR_MAX ;
	hear_inc = HEAR_INC ;
	hear_decay = HEAR_DECAY ;
	cban_cycle = GOALIE_CATCH_BAN_CYCLE ;
	verbose = FALSE ;

	dist_qstep = DIST_QSTEP ;
	land_qstep = LAND_QSTEP ;

	windir = WIND_DIR ;
	winforce = WIND_FORCE ;
	winrand = WIND_RAND ;
	win_no = FALSE ;
	win_random = FALSE ;
	useoffside = TRUE ;
	offside_area = OFFSIDE_ACTIVE_AREA_SIZE ;
	kickoffoffside = FALSE ; 
	send_log = TRUE ;
	offside_kick_margin = OFFSIDE_KICK_MARGIN ;

	/* skip command name */
	argv++ ; argc-- ;

	/* first, search option '-file' */
	int i ;
	for(i = 0 ; i < argc ; i++) {
		if (!strcmp(*(argv + i),"-file")) {
			FILE *fp ;

			if ((fp = fopen(*(argv+i+1),"r")) == NULL) {
				cerr << "cat't open config file " << *(argv+i+1) << endl ;
				break ;
			}

			char buf[MaxMesg] ;
			while(fgets(buf,MaxMesg,fp) != NULL) {
				/* ignore remark line */
				if (buf[0] == '#' || buf[0] == '\n')
					continue ;

				/* replace from ':' to ' ' */
				char *t = buf ;
				while(*t != NULLCHAR) {
					if (*t == ':') *t = ' ' ;
					t++ ;
				}

				int n, p ;
				char com[256] ;
				char onoff[16] ;
				n = sscanf(buf,"%s", com) ;
				if (n < 1) {
					cerr << "Illegal line : " << buf ;
					continue ;
				}

				for (p = 0 ; opt[p].vptr != NULL ; p++) {
					if (strcmp(com, opt[p].optname))
						continue ;

					/* match */
					switch(opt[p].vsize) {
					case VV_INT:
						n = sscanf(buf, "%s %d", com, (int *)opt[p].vptr) ;
						break ;

					case VV_STRING:
						n = sscanf(buf, "%s %s", com, (char *)opt[p].vptr) ;
						break ;

					case VV_DOUBLE:
						n = sscanf(buf, "%s %lf", com, (double *)opt[p].vptr) ;
						break ;

					case VV_BOOL:
						n = 2 ;
						*((int *)opt[p].vptr) = TRUE ;
						break ;

					case VV_ONOFF:
						n = sscanf(buf, "%s %s", com, onoff) ;
						*((int *)opt[p].vptr) = 
									(!strcmp(onoff, "on")) ? TRUE : FALSE ;
						break ;
					}

					if (n < 2)
						cerr << "Illegal line (" << com << ") " << endl ;

					break ;
				}
				
				if (opt[p].vptr == NULL)
					cerr << "Illegal line (" << com << ") " << endl ;
			}

			fclose(fp) ;
			break ;
		}
	}

	/* next, analyze command line option */
	int p ;

	while (argc) {
		if (!strcmp(*argv, "-file")) {
			argv += 2 ;
			argc -= 2 ;
			continue ;
		}
			
		for (p = 0 ; opt[p].vptr != NULL ; p++) {
			if (strcmp(*argv + 1, opt[p].optname))
				continue ;

			/* match */
			argv++ ;
			argc-- ;

			switch(opt[p].vsize) {
			case VV_INT:
				*((int *)opt[p].vptr) = atoi(*argv) ;
				break ;

			case VV_STRING:
				strcpy((char *)opt[p].vptr, *argv) ;
				break ;

			case VV_DOUBLE:
				*((double *)opt[p].vptr) = atof(*argv) ;
				break ;

			case VV_BOOL:
				*((int *)opt[p].vptr) = TRUE ;
				argv-- ;
				argc++ ;
				break ;

			case VV_ONOFF:
				*((int *)opt[p].vptr) = (!strcmp(*argv, "on")) ? TRUE : FALSE ;
				break ;
			}

			break ;
		}

		if (opt[p].vptr == NULL)
			cerr << "Unrecognized Option : " << *argv << endl ;

		argv++ ;
		argc-- ;
	}

	visangle = Deg2Rad(visangle) ;
	half_time = half_time * 1000 / sim_st ;
	send_st /= 4 ;
	kickable_area = kmargin + bsize + psize ;
	ctlradius_width = ctlradius - psize ;
}

void check(void)
{
	/* this function does nothing. */
}

void Stadium::reset_player_comm_flag()
{
	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2; i++){
		player[i]->command_done = FALSE ;
		player[i]->turn_neck_done = FALSE ;
	}
}

void Stadium::MainLoop() 
{
//	struct itimerval itv ;
//	struct sigaction alarm_action ;

	int simt = 0, sent = 0, rect = 0, sbt = 0, svt = 0;

	HANDLE hEvent;
	HANDLE hThread;
	DWORD erg;
	sleepTime = recv_st;
	hEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
	hThread = (HANDLE)_beginthread( T_DoIt, 0 , hEvent);
	SetThreadPriority(hThread,THREAD_PRIORITY_TIME_CRITICAL);
	printf("Press any key to end.\n");
	while(!_kbhit())
	{
		erg=WaitForSingleObject( hEvent, (DWORD)recv_st);

		simt += recv_st ;
		sent += recv_st ;
		rect += recv_st ;
		sbt  += recv_st ;
		svt  += recv_st ;

		if (simt >= sim_st) {
			reset_player_comm_flag() ;
			step() ;
			simt = 0 ;
		}
		if (sent >= send_st) {
			udp_send_message() ;
			sent = 0 ;
		}
		if (sbt >= sb_step) {
			int i ;
			for (i = 0 ; i < MAX_PLAYER * 2; i++)
				if (player[i]->version >= 5.0)
					player[i]->sense_body() ;
			sbt = 0 ;
		} 
		if (rect >= recv_st) {
			udp_recv_message() ;
			udp_recv_from_online_coach() ;
			if (CoachMode || CwRMode)
				udp_recv_from_coach() ;
			rect = 0 ;
		}
		if (svt >= sv_st) {
			int i ;
			if (coach->assignedp && coach->eye)
				coach->send_visual_info() ;
			for (i = 1 ; i < 3; i++)
				if (olcoach[i]->assignedp && olcoach[i]->eye)
					olcoach[i]->send_visual_info() ;
			svt = 0 ;
		} 
	}
	if (logfile[0] != NULLCHAR)
		fclose(log_fp) ;
	if (recfile[0] != NULLCHAR)
		fclose(rec_fp) ;
}

void Stadium::assign(void)
{
	field.assign(this) ;

	votable.AssignObject(&(field.goal_l)) ;
	votable.AssignObject(&(field.goal_r)) ;

	votable.AssignObject(new PObject(FLAG_C_NAME,
			PVector(0.0, 0.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_CT_NAME,
			PVector(0.0, -PITCH_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_CB_NAME,
			PVector(0.0, PITCH_WIDTH/2.0))) ;

	votable.AssignObject(new PObject(FLAG_LT_NAME,
			PVector(-PITCH_LENGTH/2.0, -PITCH_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_LB_NAME,
			PVector(-PITCH_LENGTH/2.0, PITCH_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_RT_NAME,
			PVector(PITCH_LENGTH/2.0, -PITCH_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_RB_NAME,
			PVector(PITCH_LENGTH/2.0, PITCH_WIDTH/2.0))) ;

	votable.AssignObject(new PObject(FLAG_PLT_NAME,
			PVector(-PITCH_LENGTH/2.0+PENALTY_AREA_LENGTH,
				-PENALTY_AREA_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_PLC_NAME,
			PVector(-PITCH_LENGTH/2.0+PENALTY_AREA_LENGTH, 0))) ;
	votable.AssignObject(new PObject(FLAG_PLB_NAME,
			PVector(-PITCH_LENGTH/2.0+PENALTY_AREA_LENGTH,
				PENALTY_AREA_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_PRT_NAME,
			PVector(PITCH_LENGTH/2.0-PENALTY_AREA_LENGTH,
				-PENALTY_AREA_WIDTH/2.0))) ;
	votable.AssignObject(new PObject(FLAG_PRC_NAME,
			PVector(PITCH_LENGTH/2.0-PENALTY_AREA_LENGTH, 0))) ;
	votable.AssignObject(new PObject(FLAG_PRB_NAME,
			PVector(PITCH_LENGTH/2.0-PENALTY_AREA_LENGTH,
				PENALTY_AREA_WIDTH/2.0))) ;

	votable.AssignObject(new PObject(FLAG_GLT_NAME,
			PVector(-PITCH_LENGTH/2.0, -gwidth/2.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_GLB_NAME,
			PVector(-PITCH_LENGTH/2.0, gwidth/2.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_GRT_NAME,
			PVector(PITCH_LENGTH/2.0, -gwidth/2.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_GRB_NAME,
			PVector(PITCH_LENGTH/2.0, gwidth/2.0), 4.0)) ;

	votable.AssignObject(new PObject(FLAG_TL50_NAME,
			PVector(-50.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TL40_NAME,
			PVector(-40.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TL30_NAME,
			PVector(-30.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TL20_NAME,
			PVector(-20.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TL10_NAME,
			PVector(-10.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_T0_NAME,
			PVector(0.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TR10_NAME,
			PVector(10.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TR20_NAME,
			PVector(20.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TR30_NAME,
			PVector(30.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TR40_NAME,
			PVector(40.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_TR50_NAME,
			PVector(50.0, -PITCH_WIDTH/2.0-5.0), 4.0)) ;

	votable.AssignObject(new PObject(FLAG_BL50_NAME,
			PVector(-50.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BL40_NAME,
			PVector(-40.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BL30_NAME,
			PVector(-30.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BL20_NAME,
			PVector(-20.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BL10_NAME,
			PVector(-10.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_B0_NAME,
			PVector(0.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BR10_NAME,
			PVector(10.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BR20_NAME,
			PVector(20.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BR30_NAME,
			PVector(30.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BR40_NAME,
			PVector(40.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_BR50_NAME,
			PVector(50.0, PITCH_WIDTH/2.0+5.0), 4.0)) ;

	votable.AssignObject(new PObject(FLAG_LT30_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, -30), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_LT20_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, -20), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_LT10_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, -10), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_L0_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, 0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_LB10_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, 10), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_LB20_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, 20), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_LB30_NAME,
			PVector(-PITCH_LENGTH/2.0-5.0, 30), 4.0)) ;

	votable.AssignObject(new PObject(FLAG_RT30_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, -30), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_RT20_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, -20), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_RT10_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, -10), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_R0_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, 0), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_RB10_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, 10), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_RB20_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, 20), 4.0)) ;
	votable.AssignObject(new PObject(FLAG_RB30_NAME,
			PVector(PITCH_LENGTH/2.0+5.0, 30), 4.0)) ;
}

MPObject* Stadium::NewObject(
							const MPObjectType t,
							const Name name,
							const PVector pos,
							const Value size,
							const Value angle,
							const Value decay,
							const Value rand,
							const Value weight,
							const Value speed)
{
	MPObject* obj = motable.NewObject(name) ;

	votable.AssignObject(obj) ;
	obj->stadium = this ;
	obj->weather = &weather ;
	obj->weight = weight ;
	obj->max_speed = speed ;
	obj->Set(t,pos,size,angle,PVector(0.0,0.0),PVector(0.0,0.0), decay,rand) ;

	return obj ;
}

void Stadium::assignBall(void)
{
	ball = NewObject(
			MPO_Ball,
			BALL_NAME,
			PVector(0.0,0.0),
			bsize,		/* ball size */
			0.0,		/* ball angle */
			bdecay,		/* ball decay */
			brand,		/* ball rand */ 
			bweight,	/* ball weight */ 
			bspeed_max	/* ball speed max */
			) ;
}

void Stadium::initPlayer(void)
{
	int i ;
	Player *p_l ;
	Player *p_r ;

	team_l = new Team(this, LEFT) ;
	team_r = new Team(this, RIGHT) ;

	for (i = 0; i < MAX_PLAYER; i++) {
		p_l = new Player(team_l, this, i+1) ;
		p_r = new Player(team_r, this, i+1) ;
		team_l->player[i] = p_l ;
		team_r->player[i] = p_r ;
		player[i] = p_l ;
		player[i+MAX_PLAYER] = p_r ;
		dest[i] = i ;
		dest[i+MAX_PLAYER] = i+MAX_PLAYER ;
	}
}

void Stadium::initCoach(Stadium *std)
{
	coach = new Coach(std) ;
	coach->eye = FALSE ;
}

void Stadium::initOnlineCoach(Stadium *std)
{
	OnlineCoach *p_olcoach ;

	p_olcoach = new OnlineCoach(std) ;
	team_l->olcoach = p_olcoach ;
	olcoach[1] = p_olcoach ;
	olcoach[1]->eye = FALSE ;
	p_olcoach = new OnlineCoach(std) ;
	team_r->olcoach = p_olcoach ;
	olcoach[2] = p_olcoach ;
	olcoach[2]->eye = FALSE ;
}

Player* Stadium::newPlayer(const Name teamname, Value version, int goalie_flag,
							unsigned long host, int port)
{
	Team *tm ;

	if (team_l->name == NULLCHAR) {
		tm = team_l ;
		tm->name = teamname ;
		tm->enable = TRUE ;
	}
	else if (!strcmp(team_l->name, teamname))
		tm = team_l ;
	else if (team_r->name == NULLCHAR) {
		tm = team_r ;
		tm->name = teamname ;
		tm->enable = TRUE ;
	}
	else if (!strcmp(team_r->name, teamname))
		tm = team_r ;
	else {
		if (verbose)
			cerr << "Warning:Too many teams. [teamname = '"
					<< teamname << "']" << endl ;
		return NULL ; 
	}

	Player *p = tm->newPlayer(version, goalie_flag) ;

	if (p == NULL)
		return (Player*)NULL ;

	motable.AssignObject(p) ;
	votable.AssignObject(p) ;

	udp_init(((tm->side == LEFT) ? 0 : 1) * MAX_PLAYER + p->unum, 0) ;

	p->client.host = host ;
	p->client.port = port ;

	return p ;
}

Player* Stadium::get_client_player(unsigned long host, int port)
{
	int i ; 

	for (i = 0 ; i < MAX_PLAYER * 2 ; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		if (player[i]->client.host == host &&
			player[i]->client.port == port ) 
				return player[i] ;
	}
			
	return NULL ;
}

Player* Stadium::newClient(unsigned long host, int port, char* init_message)
{
	char buffer[128], *teamname ;
	char *ptr = init_message ;
	int goalie_flag = FALSE ;
	float version = 3.0 ;
	int count = 0 ;

    if (strncmp(ptr, "(init ", 6)) {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << init_message << endl ;
		return NULL ;
	}
    ptr += 6 ;

    while (*ptr != (char)NULL) {
        if (*ptr == '(') {
            if (!strncmp(ptr, "(version ", 9)) { /* noda */
                ptr += 9 ;
                break ;
			}
            else if (!strncmp(ptr, "(goalie)", 8)) {
				ptr += 8 ;
				goalie_flag = TRUE ;
				break ;
			}
			else { 
				if (verbose)
					cerr << "Warning:Illegal team name." << endl 
						<< "   message = " << init_message << endl ;
				return NULL ;
            }
        }
        else if (*ptr == ')' ) {
			buffer[count] = NULLCHAR ;
			sscanf(buffer, "%[-_a-zA-Z0-9]", buffer) ;
			if((unsigned)count != strlen(buffer)) {
				if (verbose)
					cerr << "Warning:illegal_team_char."
						<< endl ;
			 	return NULL ;
			}
			teamname = strdup(buffer) ;
			return newPlayer(teamname, (Value)version, goalie_flag, host, port);
		}
        else {
            buffer[count++] = *ptr++ ;
			if (count > 32) {
				if (verbose)
					cerr << "Warning:Too long team name." << endl
						<< "   message = " << init_message << endl ;
				return NULL ;
			}
		}
    }
	
	if (isspace(buffer[count-1]))
		count-- ;
	buffer[count] = NULLCHAR ;
	sscanf(buffer, "%[-_a-zA-Z0-9]", buffer) ;
	if((unsigned)count != strlen(buffer)) {
		if (verbose)
			cerr << "Warning:illegal_team_char." << endl ;
	 	return NULL ;
	}
	teamname = strdup(buffer) ;

    while (*ptr != (char)NULL) {
        if (isspace(*ptr))
            ptr++ ;
        else
            break ;
	}

	if (goalie_flag) {
		if (!strncmp(ptr, "(version ", 9))
			ptr += 9 ;
		else { 
			if (verbose)
				cerr << "Warning:Illegal team name." << endl 
					<< "   message = " << init_message << endl ;
			return NULL ;
		}
	}
		
    if (!sscanf(ptr, "%f", &version)) {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << init_message << endl ;
		return NULL ;
	}
    while (*ptr != (char)NULL) {
        if (isdigit(*ptr) || *ptr == '.' || isspace(*ptr))
            ptr++ ;
        else
            break ;
	}

    if (*ptr++ != ')') {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << init_message << endl ;
		return NULL ;
	}

    while (*ptr != (char)NULL) {
        if (isspace(*ptr))
            ptr++ ;
        else
            break ;
	}

    if (*ptr == ')') {
		return newPlayer(teamname, (Value)version, goalie_flag, host, port) ;
	}

    if (strncmp(ptr, "(goalie)", 8)) {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << init_message << endl ;
		return NULL ;
	}

    goalie_flag = TRUE ;
	return newPlayer(teamname, (Value)version, goalie_flag, host, port) ;
}

OnlineCoach* Stadium::newCoach(unsigned long host, int port, char* init_message)
{
	char buffer[128], *teamname ;
	char *ptr = init_message ;
	int goalie_flag = FALSE ;
	float version = 3.0 ;
	int count = 0 ;

    if (strncmp(ptr, "(init ", 6)) {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << init_message << endl ;
		return NULL ;
	}
    ptr += 6 ;

    while (*ptr != (char)NULL) {
    	if (*ptr == ')' ) {
		buffer[count] = NULLCHAR ;
		teamname = strdup(buffer) ;
		if (team_l->name != NULLCHAR && !strcmp(team_l->name, teamname)) {
			if(team_l->olcoach->assignedp == TRUE) {
				return NULL ;
			}
			team_l->olcoach->assignedp = TRUE ;
        	team_l->olcoach->client.host = host ;
        	team_l->olcoach->client.port = port ;
			team_l->olcoach->side = LEFT ;
			udp_init(-1, 0) ;
			team_l->olcoach->udp_send("(init ok)") ;
			return team_l->olcoach ;
    	}else if (team_r->name != NULLCHAR && !strcmp(team_r->name, teamname)) {
			if(team_r->olcoach->assignedp == TRUE) {
				return NULL ;
			}
			team_r->olcoach->assignedp = TRUE ;
        	team_r->olcoach->client.host = host ;
        	team_r->olcoach->client.port = port ;
			team_r->olcoach->side = RIGHT ;
			udp_init(-2, 0) ;
			team_r->olcoach->udp_send("(init ok)") ;
			return team_r->olcoach ;
      	}else {
               		return NULL ; 
       	}
	}
	else {
		buffer[count++] = *ptr++ ;
			if (count > 32) {
				if (verbose)
					cerr << "Warning:Too long team name." << endl
						<< "   message = " << init_message << endl ;
				return NULL ;
			}
		}
    }
	return NULL;
}

Player* Stadium::reconnectClient(unsigned long host, int port,
										char* reconnect_message)
{
	char buffer[128] ;
	int r ;
	ID rnum ;

	r = sscanf(reconnect_message,"(reconnect %s %d)", buffer, &rnum) ;

	if(r < 2) {
		if (verbose)
			cerr << "Warning:Illegal initialize message." << endl 
					<< "   message = " << reconnect_message << endl ;
		return NULL ;
	}

	for(r = 0 ; r < MAX_PLAYER * 2; r++)
		if (player[r]->team->enable)
			if (!strcmp(player[r]->team->name,buffer)
				&& player[r]->unum == rnum)
					break ;

	/* It's same. */
	if (r < MAX_PLAYER * 2) {
		udp_init(((player[r]->team->side == LEFT) ? 0 : 1) * MAX_PLAYER
					+ player[r]->unum, 0) ;
		player[r]->client.host = host ;
		player[r]->client.port = port ;
		player[r]->alive = STAND ;
		player[r]->enable = TRUE ;
		if (player[r]->goalie)
			player[r]->alive |= GOALIE ;
		return player[r] ;
	}
	else 
		return NULL ;
}

void Stadium::byeClient(Player* bye)
{
	if (bye->goalie == TRUE && bye->team->side == caught_ball)
		caught_ball = FALSE ;
	bye->enable = FALSE ;
	bye->client.host = 0 ;
	bye->client.port = -1 ;
	bye->alive = DISABLE ;
	bye->pos.x = -(bye->unum * 3 * bye->team->side) ;
	bye->pos.y = -PITCH_WIDTH/2.0 - 3.0 ;
	socketfd[((bye->team->side == LEFT) ? 0 : 1 )*MAX_PLAYER + bye->unum] = -1 ;
}

void Stadium::step() 
{
	int i ;

	if (mode == PM_BeforeKickOff) {
                motable._turn();
		check_players_move() ;
	}
	else if (mode == PM_AfterGoal_Right) {
		caught_ball = FALSE ;
		++motable ; 
		if (++after_g_time > AFTER_GOAL_WAIT) {
			set_ball(PVector(0.0,0.0),LEFT) ;
			set_players() ;
			change_play_mode(PM_KickOff_Left) ;
		}
	}
	else if (mode == PM_AfterGoal_Left) {
		caught_ball = FALSE ;
		++motable ; 
		if (++after_g_time > AFTER_GOAL_WAIT) {
			set_ball(PVector(0.0,0.0),RIGHT) ;
			set_players() ;
			change_play_mode(PM_KickOff_Right) ;
		}
	}
	else if (mode == PM_OffSide_Right) {
		caught_ball = FALSE ;
		++motable ; 
		check_player_after_offside() ;
		if (++after_offside_time > AFTER_OFFSIDE_WAIT) {
			change_play_mode(PM_FreeKick_Left) ;
		}
	}
	else if (mode == PM_OffSide_Left) {
		caught_ball = FALSE ;
		++motable ; 
		check_player_after_offside() ;
		if (++after_offside_time > AFTER_OFFSIDE_WAIT) {
			change_play_mode(PM_FreeKick_Right) ;
		}
	}
	else if (mode != PM_BeforeKickOff && mode != PM_TimeOver) {
		++motable ; 
		if (useoffside)
			offside_check() ;
		time++ ;
		referee_step() ;
		if (caught_ball && mode != PM_BeforeKickOff) {
			PVector temp(last_touch->relative_ball_ang.x,
					last_touch->relative_ball_ang.y);
			check_goalie_while_catch(last_touch) ;
			temp *= (psize+bsize);
			ball->pos = last_touch->pos + temp;
		}
		prev_ball_pos = ball->pos ;
		dinfo.body.show.time = htons(time) ;
	}

	for (i = 0 ; i < MAX_PLAYER * 2; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		if (player[i]->stamina <= recover_dthr * stamina_max) {
			if (player[i]->recovery > recover_min)
				player[i]->recovery -= recover_dec ;
		}
		if (player[i]->stamina <= effort_dthr * stamina_max) {
			if (player[i]->effort > effort_min)
				player[i]->effort -= effort_dec ;
		}
		if (player[i]->stamina >= effort_ithr * stamina_max) {
			if (player[i]->effort < 1.0) { 
				player[i]->effort += effort_inc ;
				if (player[i]->effort > 1.0)
					player[i]->effort = 1.0 ;
			}
		}
		player[i]->stamina += player[i]->recovery * stamina_inc ;
		if (player[i]->stamina > stamina_max)
			player[i]->stamina = stamina_max ;

		player[i]->hear_capacity_from_teammate += hear_inc ;
		if (player[i]->hear_capacity_from_teammate > hear_max)
			player[i]->hear_capacity_from_teammate = hear_max ;

		player[i]->hear_capacity_from_opponent += hear_inc ;
		if (player[i]->hear_capacity_from_opponent > hear_max)
			player[i]->hear_capacity_from_opponent = hear_max ;
		if (player[i]->goalie_catch_ban)
			player[i]->goalie_catch_ban-- ;
	}

	/* send to displays */
	dinfo.body.show.pos[0].x = htons((short)(ball->pos.x * SHOWINFO_SCALE)) ;
	dinfo.body.show.pos[0].y = htons((short)(ball->pos.y * SHOWINFO_SCALE)) ;

	for (i = 0 ; i < MAX_PLAYER * 2 ; i++) {
		dinfo.body.show.pos[i+1].enable = htons(player[i]->alive) ; 
		player[i]->alive &= (STAND | GOALIE | DISCARD) ;
		dinfo.body.show.pos[i+1].x =
			htons((short)(player[i]->pos.x * SHOWINFO_SCALE)) ;
		dinfo.body.show.pos[i+1].y =
			htons((short)(player[i]->pos.y * SHOWINFO_SCALE)) ;
		dinfo.body.show.pos[i+1].angle = htons((short)Rad2Deg(player[i]->angle)) ;
		dinfo.body.show.pos[i+1].side = htons(player[i]->team->side) ;
		dinfo.body.show.pos[i+1].unum = htons(player[i]->unum) ;
	}
	if (team_l->name != NULLCHAR) {
		strcpy(dinfo.body.show.team[0].name, team_l->name) ;
		dinfo.body.show.team[0].score = htons(team_l->point) ;
	}
	if (team_r->name != NULLCHAR) {
		strcpy(dinfo.body.show.team[1].name, team_r->name) ;
		dinfo.body.show.team[1].score = htons(team_r->point) ;
	}

	displist_t *p ;
	for (p = top.next ; p != NULL ; p = p->next)
		udp_send(&dinfo,p->shost,p->sport,0) ;

	if (recfile[0] != NULLCHAR)
		if (mode != PM_BeforeKickOff && mode != PM_TimeOver)
			WriteLog(&dinfo) ;
}


/*
 *===================================================================
 *Part: Field
 *===================================================================
 */
void Field::assign(Stadium *std)
{
	goal_l.name = GOAL_L_NAME ;
	goal_r.name = GOAL_R_NAME ;
	line_l.name = LINE_L_NAME ;
	line_r.name = LINE_R_NAME ;
	line_t.name = LINE_T_NAME ;
	line_b.name = LINE_B_NAME ;

	goal_l.Set(PVector(-PITCH_LENGTH/2.0,0.0),std->gwidth) ;
	goal_r.Set(PVector(PITCH_LENGTH/2.0,0.0),std->gwidth) ;
	line_l.Set(PVector(-PITCH_LENGTH/2.0,0.0),1.0) ;
	line_r.Set(PVector(PITCH_LENGTH/2.0,0.0),1.0) ;
	line_t.Set(PVector(-PITCH_WIDTH/2.0,0.0),1.0) ;
	line_b.Set(PVector(-PITCH_WIDTH/2.0,0.0),1.0) ;
}

/*
 *===================================================================
 *Part: Referee
 *===================================================================
 */
void Stadium::referee_step()
{
	/* if a value of half_time is negative, then ignore time. */
	if(half_time > 0) {
		/* check half_time and time_over. */
		if(time >= half_time * 2) {
			if (!team_l || !team_r) {
				say("time_up_without_a_team") ;
				change_play_mode(PM_TimeOver) ;
				return ;
			}
			else if (team_l->point != team_r->point) {
				say("time_up") ;
				change_play_mode(PM_TimeOver) ;
				return ;
			}
			else if (startp) {
				say("time_extended") ;
				set_ball(PVector(0.0,0.0),LEFT) ;
				set_players() ;
				change_play_mode(PM_BeforeKickOff) ;
				time = half_time * 2 ;
				weather.wind_vector.x *= -1 ;
				weather.wind_vector.y *= -1 ;
				startp = FALSE ;
				return ;
			}
		}
		else if(time >= half_time && !startp) {
			caught_ball = FALSE ;
			say("half_time") ;
			set_ball(PVector(0.0,0.0),RIGHT) ;
			set_players() ;
			change_play_mode(PM_BeforeKickOff) ;
			time = half_time ;
			startp = TRUE ;
			weather.wind_vector.x *= -1 ;
			weather.wind_vector.y *= -1 ;
			return ;
		}
	}

	if(!CoachMode) {
		check_mode() ;
		check_goal() ;
		check_ball_in_pitch() ;
		check_player_in_field() ;
		return ;
	}
	if(!coach->assignedp) {
		check_mode() ;
		check_goal() ;
		check_ball_in_pitch() ;
	} else
		if(check_ball_pos() != BPI_InField)
			ball->vel = PVector(0.0,0.0) ;

	check_player_in_field() ;
}

void Stadium::check_mode()
{
	if (mode == PM_GoalKick_Right || mode == PM_GoalKick_Left) {
	        check_field_before_goalkick() ;
		check_player_in_field() ;
		}
	else if (mode != PM_PlayOn)
		if(ball->vel.x != 0.0 || ball->vel.y != 0.0){
			check_player_in_field() ;
			change_play_mode(PM_PlayOn) ;
		}
}

void Stadium::set_ball(PVector p,Side s, PVector vel)
{
    ball->acc = PVector(0.0,0.0) ;
    ball->vel = vel ;
    ball->pos = p ;
    kick_off_side = s ;
}

void Stadium::set_ball(PVector p,Side s,Angle ang, PVector vel)
{
    ball->angle = ang ;
    set_ball(p, s, vel) ;
}

void Stadium::check_players_move()
{
	static RArea fld_l(PVector(-PITCH_LENGTH/4,0.0),
					PVector(PITCH_LENGTH/2, PITCH_WIDTH)) ;
	static RArea fld_r(PVector(PITCH_LENGTH/4,0.0),
					PVector(PITCH_LENGTH/2, PITCH_WIDTH)) ;
	static CArea c(PVector(0.0,0.0),KICK_OFF_CLEAR_DISTANCE) ;

	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2 ; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		switch (player[i]->team->side) {
		case LEFT:
			if(player[i]->pos.x > 0)
				player[i]->pos = fld_l.randomize() ;
			break ;
		case RIGHT:
			if(player[i]->pos.x < 0)
				player[i]->pos = fld_r.randomize() ;
			break ;
		}
		if(player[i]->team->side != kick_off_side)
			if(c.inArea(player[i]->pos))
				player[i]->pos = c.nearestEdge(player[i]->pos) ;
	}
}

void Stadium::check_player_after_offside()
{

    CArea c(offside_pos, offside_area) ;

	int offsideside ;
	PVector ce, si ;

    if (mode == PM_OffSide_Right) {
        ce += PVector(PITCH_LENGTH/4 + offside_pos.x/2,0.0) ;
		si += PVector(PITCH_LENGTH/2 - offside_pos.x, PITCH_WIDTH) ;
		offsideside = RIGHT ;
	}
	else {
        ce += PVector(-PITCH_LENGTH/4 + offside_pos.x/2,0.0) ;
		si += PVector(PITCH_LENGTH/2 + offside_pos.x, PITCH_WIDTH) ;
		offsideside = LEFT ;
    }
    RArea fld(ce, si) ;

	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2 ; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		if (player[i]->team->side == offsideside) {
			if (c.inArea(player[i]->pos))
				player[i]->pos = c.nearestEdge(player[i]->pos) ;
			if (!fld.inArea(player[i]->pos))
				if(mode == PM_OffSide_Right)
					player[i]->pos = fld.nearestVEdge(player[i]->pos)
						+ PVector(offside_kick_margin,0) ;
				else
					player[i]->pos = fld.nearestVEdge(player[i]->pos)
						- PVector(offside_kick_margin,0) ;
		}
	}
}

void Stadium::check_goalie_while_catch(Player *goalie)
{
	RArea pta(PVector((-PITCH_LENGTH/2+PENALTY_AREA_LENGTH/2.0) * goalie->team->side, 0.0),
					 PVector(PENALTY_AREA_LENGTH, PENALTY_AREA_WIDTH)) ;
	if (!(pta.inArea(goalie->pos)))
		goalie->pos = pta.nearestEdge(goalie->pos) ;
}

void Stadium::check_field_before_goalkick()
{
	static RArea p_l(PVector(-PITCH_LENGTH/2+PENALTY_AREA_LENGTH/2.0, 0.0),
					 PVector(PENALTY_AREA_LENGTH, PENALTY_AREA_WIDTH)) ;
	static RArea p_r(PVector(+PITCH_LENGTH/2-PENALTY_AREA_LENGTH/2.0, 0.0),
					 PVector(PENALTY_AREA_LENGTH, PENALTY_AREA_WIDTH)) ;
	RArea* fld ;

	int oppside ;

	if (mode == PM_GoalKick_Left) {
                oppside = RIGHT ;
		fld = &p_l ;
	} else {
                oppside = LEFT ;
		fld = &p_r ;
        }

	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2 ; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		if (player[i]->team->side == oppside) {
			if ((fld->inArea(player[i]->pos)))
				player[i]->pos = fld->nearestEdge(player[i]->pos) ;
			if ( player[i]->pos.x * oppside >= PITCH_LENGTH/2)
				player[i]->pos.x = (PITCH_LENGTH/2 - PENALTY_AREA_LENGTH) * oppside ;
		}
	}
	if(!(fld->inArea(ball->pos))){
		check_player_in_field() ;
		change_play_mode(PM_PlayOn) ;
        }
}

void Stadium::set_players()
{
	static RArea fld_l(PVector(-PITCH_LENGTH/4,0.0),
					PVector(PITCH_LENGTH/2, PITCH_WIDTH)) ;
	static RArea fld_r(PVector(PITCH_LENGTH/4,0.0),
					PVector(PITCH_LENGTH/2, PITCH_WIDTH)) ;
	static CArea c(PVector(0.0,0.0),KICK_OFF_CLEAR_DISTANCE) ;

	int i ;

	c.center = ball->pos ;

	for (i = 0 ; i < MAX_PLAYER * 2; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		switch (player[i]->team->side) {
		case LEFT:
			if(!(fld_l.inArea(player[i]->pos)))
				player[i]->pos = fld_l.randomize() ;
			break ;
		case RIGHT:
			if(!(fld_r.inArea(player[i]->pos)))
				player[i]->pos = fld_r.randomize() ;
			break ;
		}
		if(player[i]->team->side != kick_off_side)
			if(c.inArea(player[i]->pos))
				player[i]->pos = c.nearestEdge(player[i]->pos) ;
	}
}

void Stadium::recovery_players()
{
	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		player[i]->stamina = stamina_max ;
		player[i]->recovery = 1.0 ;
		player[i]->effort = 1.0 ;
		player[i]->hear_capacity_from_teammate = hear_max ;
		player[i]->hear_capacity_from_opponent = hear_max ;
	}
}

void Stadium::announce_goal(Team& tm)
{
	static char buf[MaxStringSize] ;

	sprintf(buf,"goal_%s_%d",SideStr(tm.side),tm.point) ;
	say(buf) ;
}

BallPosInfo Stadium::check_ball_pos()
{
	static RArea g_l(PVector((-PITCH_LENGTH-GOAL_DEPTH)/2.0,0.0),
			PVector(GOAL_DEPTH,gwidth)) ;
	static RArea g_r(PVector((+PITCH_LENGTH+GOAL_DEPTH)/2.0,0.0),
			PVector(GOAL_DEPTH,gwidth)) ;

	static RArea pt(PVector(0.0,0.0),
			PVector(PITCH_LENGTH,PITCH_WIDTH)) ;

	if(g_l.inArea(ball->pos)) return BPI_GoalL ;
	if(g_r.inArea(ball->pos)) return BPI_GoalR ;
	if(!(pt.inArea(ball->pos))) return BPI_OutOfField ;
	return BPI_InField ;
}

Logical Stadium::cross_gline(Side side)
{
	static double tmp ;

	if (prev_ball_pos.x == ball->pos.x)
		return FALSE ;

	if (fabs(ball->pos.x) < PITCH_LENGTH/2.2)
		return FALSE ;

	if ((side * ball->pos.x) >= 0)
		return FALSE ;

	tmp = ((prev_ball_pos.y - ball->pos.y) * (PITCH_LENGTH/2.0) * (-side)
			+ prev_ball_pos.x * ball->pos.y - ball->pos.x * prev_ball_pos.y)
				/ (prev_ball_pos.x - ball->pos.x) ;

	if (tmp >= -gwidth/2 && tmp <= gwidth/2)
		return TRUE ;
	else
		return FALSE ;

}

void Stadium::check_goal()
{
	static RArea pt(PVector(0.0,0.0),
				PVector(PITCH_LENGTH,PITCH_WIDTH)) ;

	if ((pt.inArea(ball->pos)))
		return ;

	if (cross_gline(LEFT)) {
		if (team_r) {
			team_r->point++ ;
			announce_goal(*team_r) ;
			after_g_time = 0 ;
			set_ball(ball->pos, LEFT) ;
			if (half_time >= 0 && time >= half_time * 2)
				change_play_mode(PM_TimeOver) ;
			else {
				mode = PM_AfterGoal_Right ;
				dinfo.body.show.pmode = (char)PM_AfterGoal_Right ;
			}
		}
	}
	else if (cross_gline(RIGHT)) {
		if (team_l) {
			team_l->point++ ;
			announce_goal(*team_l) ;
			after_g_time = 0 ;
			set_ball(ball->pos, RIGHT) ;
			if (half_time >= 0 && time >= half_time * 2)
				change_play_mode(PM_TimeOver) ;
			else {
				mode = PM_AfterGoal_Left ;
				dinfo.body.show.pmode = (char)PM_AfterGoal_Left ;
			}
		}
	}
}

void Stadium::check_ball_in_pitch()
{
	static RArea pt(PVector(0.0,0.0),
				PVector(PITCH_LENGTH,PITCH_WIDTH)) ;
	PVector pos ;

	if (mode == PM_AfterGoal_Left ||
				mode == PM_AfterGoal_Right || mode == PM_TimeOver)
		return ;

	if (pt.left > ball->pos.x) {
		Side side = last_touch->team->side ;
		if(side == LEFT) {
			pos = pt.nearestHEdge(ball->pos) ;
			pos.x += ckmargin ;
			if ( pos.y > 0 )
				pos.y -= ckmargin ;
			else
				pos.y += ckmargin ;
				set_ball(pos, -side) ;
			change_play_mode(PM_CornerKick_Right) ;
		}
		else {
			PVector r(-PITCH_LENGTH/2.0+GOAL_AREA_LENGTH,
						((ball->pos.y > 0) ? 1 : -1) * GOAL_AREA_WIDTH/2.0) ;
			set_ball(r,-side) ;
			change_play_mode(PM_GoalKick_Left) ;
		}
	}
	else if (pt.right < ball->pos.x) {
		Side side = last_touch->team->side ;
		if(side == RIGHT) {
			pos = pt.nearestHEdge(ball->pos) ;
			pos.x -= ckmargin ;
			if ( pos.y > 0 )
				pos.y -= ckmargin ;
			else
				pos.y += ckmargin ;
			set_ball(pos, -side) ;
			change_play_mode(PM_CornerKick_Left) ;
		}
		else {
			PVector r(PITCH_LENGTH/2.0-GOAL_AREA_LENGTH,
						((ball->pos.y > 0) ? 1 : -1) * GOAL_AREA_WIDTH/2.0) ;
			set_ball(r,-side) ;
			change_play_mode(PM_GoalKick_Right) ;
		}
	}
	else if (!(pt.inArea(ball->pos))) {
		Side side = last_touch->team->side ;
		set_ball(pt.nearestHEdge(ball->pos), -side) ; 
		if (side == LEFT)
			change_play_mode(PM_KickIn_Right) ;
		else
			change_play_mode(PM_KickIn_Left) ;
	} 
}

void Stadium::check_player_in_field()
{
	static RArea fld(PVector(0.0,0.0),
					PVector(PITCH_LENGTH+PITCH_MARGIN*2.0,
					PITCH_WIDTH+PITCH_MARGIN*2.0)) ;
	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2; i++ ) {
		if (player[i]->alive == DISABLE)
			continue ;
		if(!(fld.inArea(player[i]->pos)))
			player[i]->pos = fld.nearestEdge(player[i]->pos) ;
	}

	if (mode != PM_PlayOn && mode != PM_GoalKick_Left && mode != PM_GoalKick_Right) {
		static CArea c(PVector(0.0,0.0), KICK_OFF_CLEAR_DISTANCE) ;
			c.center = ball->pos ;

		for(i = 0 ; i < MAX_PLAYER * 2; i++ ) {
			if (player[i]->alive == DISABLE)
				continue ;
			if(player[i]->team->side != kick_off_side)
				if(c.inArea(player[i]->pos))
					player[i]->pos = c.nearestEdge(player[i]->pos) ;
		}
	}

	if (kickoffoffside == TRUE) { 
		if (mode == PM_KickOff_Left) {
			for(i = 0 ; i < MAX_PLAYER * 2 ; i++ ) {
				if (player[i]->alive == DISABLE)
					continue ;
				if(player[i]->team->side == kick_off_side) {
					if(player[i]->pos.x > 0)
						player[i]->pos.x = 0 ;
				}
				else {
					if(player[i]->pos.x < 0)
						player[i]->pos.x = 0 ;
				}
			}
		}
		if(mode == PM_KickOff_Right) {
			for(i = 0 ; i < MAX_PLAYER * 2 ; i++ ) {
				if (player[i]->alive == DISABLE)
					continue ;
				if(player[i]->team->side == kick_off_side) {
					if(player[i]->pos.x < 0)
						player[i]->pos.x = 0 ;
				}
				else {
					if(player[i]->pos.x > 0)
						player[i]->pos.x = 0 ;
				}
			}
		}
	}
}

void Stadium::change_play_mode(PlayMode pm)
{
	static char *PlayModeString[] = PLAYMODE_STRINGS ;
	int i ;
	mode = pm ;
	dinfo.body.show.pmode = (char)pm ;

	if (pm == PM_KickOff_Left ||
		pm == PM_KickIn_Left ||
		pm == PM_FreeKick_Left ||
		pm == PM_CornerKick_Left ||
		pm == PM_GoalKick_Left)
			kick_off_side = LEFT ;
	else if (pm == PM_KickOff_Right ||
		pm == PM_KickIn_Right ||
		pm == PM_FreeKick_Right ||
		pm == PM_CornerKick_Right ||
		pm == PM_GoalKick_Right)
			kick_off_side = RIGHT ;
	else if (pm == PM_Drop_Ball)
		kick_off_side = NEUTRAL ;
	if (pm != PM_PlayOn)
		for (i = 0; i < MAX_PLAYER * 2; i++)
			player[i]->offside_mark = FALSE ;

	say(PlayModeString[pm]) ;
}

void Stadium::referee_get_foul(double x, double y, int side)
{
	char msg[8] ;

	sprintf(msg,"foul_%s", SideStr(-side)) ;
	say(msg) ;
	caught_ball = FALSE ;
	(side == LEFT) ? 
		change_play_mode(PM_FreeKick_Left) : change_play_mode(PM_FreeKick_Right) ;
	set_ball(PVector(x,y),side) ;
	check_player_in_field() ;
}

void Stadium::referee_drop_ball(double x, double y, int side)
{
	change_play_mode(PM_Drop_Ball) ;
	set_ball(PVector(x,y),side) ;
	check_player_in_field() ;
	change_play_mode(PM_PlayOn) ;
	caught_ball = FALSE ;
}

void Stadium::discard_player(int side, int unum)
{
	int i ;

	for (i = 0; i < MAX_PLAYER * 2; i++) {
		if (player[i]->team->side == side && player[i]->unum == unum)
			break ;
	}

	if (i < MAX_PLAYER * 2) {
		if (player[i]->alive & STAND) {
			if (!(player[i]->alive & DISCARD))
				player[i]->alive |= DISCARD ;
			else
				player[i]->alive &= ~DISCARD ;
		}
	}
}

void Stadium::goalie_catch(Player *goalie)
{
	char msg[32] ;

	sprintf(msg,"goalie_catch_ball_%s", SideStr(goalie->team->side)) ;
	say(msg) ;
	(goalie->team->side == LEFT) ? 
		change_play_mode(PM_FreeKick_Left) : change_play_mode(PM_FreeKick_Right) ;
	set_ball(ball->pos, goalie->team->side) ;
	caught_ball = goalie->team->side ;
	last_touch = goalie ;
	check_player_in_field() ;
}

int Stadium::mark_offside_mark(Player *kicker)
{
	double fast = 0 ;
	double second = 0 ;
	double offside_line ;
	double tmp ;
	int i ;

	if (kicker->offside_mark) {
		offside_pos = kicker->offside_pos ;
		offside() ;
		return TRUE ;
	}

	for (i = 0; i < MAX_PLAYER * 2; i++)
		player[i]->offside_mark = FALSE ;

	switch (kicker->team->side) {
	  case LEFT:
		for (i = 0; i < MAX_PLAYER * 2; i++) {
			if (player[i]->alive == DISABLE)
				continue ;
			if (player[i]->team->side == RIGHT)
				if (player[i]->pos.x > second) {
					second = player[i]->pos.x ;
					if (second > fast) {
						tmp = fast ;
						fast = second ;
						second = tmp ;
					}
				}
		}

		if (second > ball->pos.x)
			offside_line = second ;
		else
			offside_line = ball->pos.x ;

		for (i = 0; i < MAX_PLAYER * 2; i++) {
			if (player[i]->alive == DISABLE)
				continue ;
			if (player[i]->team->side == LEFT &&
				player[i]->pos.x > offside_line &&
				player[i]->unum != kicker->unum) {
					player[i]->offside_mark = TRUE ;
					player[i]->offside_pos.x = offside_line ;
					player[i]->offside_pos.y = player[i]->pos.y ;
				}
		}
		break ;

	  case RIGHT:	  
		for (i = 0; i < MAX_PLAYER * 2; i++) {
			if (player[i]->alive == DISABLE)
				continue ;
			if (player[i]->team->side == LEFT)
				if (player[i]->pos.x < second) {
					second = player[i]->pos.x ;
					if (second < fast) {
						tmp = fast ;
						fast = second ;
						second = tmp ;
					}
				}
		}

		if (second < ball->pos.x)
			offside_line = second ;
		else
			offside_line = ball->pos.x ;

		for (i = 0; i < MAX_PLAYER * 2; i++) {
			if (player[i]->alive == DISABLE)
				continue ;
			if (player[i]->team->side == RIGHT &&
				player[i]->pos.x < offside_line &&
				player[i]->unum != kicker->unum) {
					player[i]->offside_mark = TRUE ;
					player[i]->offside_pos.x = offside_line ;
					player[i]->offside_pos.y = player[i]->pos.y ;
				}
		}
		break ;
	}
	return FALSE ;
}

void Stadium::offside_check(void)
{
	int i ;
	double dist = offside_area ;
	double tmp ;

	for (i = 0; i < MAX_PLAYER * 2; i++)
		if (player[i]->offside_mark)
			if ((tmp = player[i]->pos.distance(ball->pos)) < dist) {
				dist = tmp ;
				offside_pos = player[i]->offside_pos ;
			}

	if (dist != offside_area)
		offside() ;
}

void Stadium::offside(void)
{
	PVector pos ;

	static RArea pt(PVector(0.0,0.0),
			PVector(PITCH_LENGTH - 2.0*ckmargin , PITCH_WIDTH - 2.0*ckmargin)) ;
	static RArea g_l(PVector(-PITCH_LENGTH/2.0+GOAL_AREA_LENGTH/2.0, 0.0),
							PVector(GOAL_AREA_LENGTH, GOAL_AREA_WIDTH)) ;
	static RArea g_r(PVector(+PITCH_LENGTH/2.0-GOAL_AREA_LENGTH/2.0, 0.0),
							PVector(GOAL_AREA_LENGTH, GOAL_AREA_WIDTH)) ;
	(last_kicker->team->side == LEFT) ? 
		change_play_mode(PM_OffSide_Left) : change_play_mode(PM_OffSide_Right) ;

	after_offside_time = 0 ;

	if (offside_pos.x > PITCH_LENGTH/2.0 || g_r.inArea(offside_pos)) {
		pos.x = +PITCH_LENGTH/2.0-GOAL_AREA_LENGTH ;
		pos.y = ((offside_pos.y > 0) ? 1 : -1) * GOAL_AREA_WIDTH/2.0 ;
	}
	else if (offside_pos.x < -PITCH_LENGTH/2.0 || g_l.inArea(offside_pos)) {
		pos.x = -PITCH_LENGTH/2.0+GOAL_AREA_LENGTH ;
		pos.y = ((offside_pos.y > 0) ? 1 : -1) * GOAL_AREA_WIDTH/2.0 ;
	}
	else if (!(pt.inArea(offside_pos)))
		pos = pt.nearestEdge(offside_pos) ;
	else
		pos = offside_pos ;

	set_ball(pos, -last_kicker->team->side) ; 
	check_player_in_field() ;
}

/*
 *===================================================================
 *Part: Weather
 *===================================================================
 */
void Weather::init(Stadium *std)
{
	if (std->win_no) {
		wind_vector = PVector(0.0, 0.0) ;
		wind_rand = 0.0 ;
	}
	else if (std->win_random) {
		wind_vector = Polar2PVector(drand(0, 100), Deg2Rad(drand(-180, 180))) ;
		wind_rand = drand(0, 0.5) ;
	}
	else {
		wind_vector = Polar2PVector(std->winforce, Deg2Rad(std->windir)) ;
		wind_rand = std->winrand ;
	}

#if 1
	printf("wind factor: rand: %f, vector: (%f, %f)\n",
						wind_rand, wind_vector.x, wind_vector.y) ;
#endif

}

/*
 *===================================================================
 *Part: Coach
 *===================================================================
 */
Player* Stadium::get_player_by_name(char *name)
{
	int i ;

	for (i = 0 ; i < MAX_PLAYER * 2; i++) {
		if (player[i]->alive == DISABLE)
			continue ;
		if(!strcmp(player[i]->name,name))
			return player[i] ;
	}

	return NULL ;
} 

void Stadium::move_object(char *obj_name, PVector pos, PVector vel) 
{
    Player *p ;
    if ((p = get_player_by_name(obj_name)) == NULL) {
        if (verbose)
            cerr << "unknown name" << endl ;
        return ;
    }

    p->pos = pos ;
    p->vel = vel ;
}

void Stadium::move_object(char *obj_name, PVector pos, Angle ang, PVector vel) 
{
    Player *p ;
    if ((p = get_player_by_name(obj_name)) == NULL) {
        if (verbose)
            cerr << "unknown name" << endl ;
        return ;
    }

    p->pos = pos ;
    p->vel = vel ;
    p->rotate_to(ang) ;
}

void Stadium::check_collision(char *obj_name) 
{
	int i ;
	MPObject *obj = new MPObject();

	for(i = 0; i < motable.n; i++)
		if (!strcmp(obj_name, motable.object[i]->name))
			obj = motable.object[i] ;
	
	check_collision(obj) ;
}

void Stadium::check_collision(MPObject *obj) 
{
	int i ;
	MPObject *ob ;

	for(i = 0; i < motable.n; i++) {
		ob = motable.object[i] ;
		if (obj->collisionP(*ob))
			obj->pos.x += ob->size + obj->size ;
	}
}

void _Start(Stadium& std)
{
	if(std.time == 0 || std.time == std.half_time * 2) {
		std.recovery_players() ;
		std.set_ball(PVector(0.0,0.0),LEFT) ;
		std.change_play_mode(PM_KickOff_Left) ;
	}
	else if(std.time == std.half_time) {
		std.recovery_players() ;
		std.set_ball(PVector(0.0,0.0),RIGHT) ;
		std.change_play_mode(PM_KickOff_Right) ;
	}
}

void Stadium::OpenForWrite(void)
{
	char	buf[5] ;

	// open the file
	if ((rec_fp = fopen(recfile, "w")) == NULL){
		cerr << "can't open record_file " << recfile << endl ;
	}

	if (rec_ver == REC_VERSION_2) {
		// write version information
		buf[0] = 'U' ;
		buf[1] = 'L' ;
		buf[2] = 'G' ;
		buf[3] = REC_VERSION_2 ;
		fwrite(buf, 4, 1, rec_fp) ;
		fflush(rec_fp) ;
	}
}

void Stadium::WriteLog(dispinfo_t* msg)
{
	short	len = 1 ;

	if (rec_ver == REC_VERSION_2) {
		// write the type of next msg
		if (msg->mode != MSG_MODE || rec_msg_mode) {
			fwrite((char *)(&msg->mode), sizeof(msg->mode), 1, rec_fp) ;

			switch (ntohs(msg->mode)) {
			case SHOW_MODE:
				// write a show struct
				fwrite((char *)(&msg->body.show), 
						sizeof(msg->body.show), 1, rec_fp) ;
				break ;
			case MSG_MODE:
				// it is a message write the board info
				fwrite((char *)(&msg->body.msg.board), 
						sizeof(msg->body.msg.board), 1, rec_fp);

				// calculate the string length and write it
				while ((msg->body.msg.message[len-1] != '\0') && (len < 2048))
					len++;
				fwrite((char *)(&len), sizeof(len), 1, rec_fp);

				// write the message
				fwrite(msg->body.msg.message, len, 1, rec_fp);
				break ;
			}
		}
	}
	else
		fwrite((char *)&msg, sizeof(dispinfo_t), 1, rec_fp) ;
	fflush(rec_fp) ;
}
