/* Copyright 1993 Philip F. McLauchlan (pm@robots.oxford.ac.uk) and
                  Ian Reid (ian@robots.oxford.ac.uk)
                  Robotics Research Group, Oxford University. */
/* included from global/error.h */

#define HORATIO_OK                0

/* global library error codes */
#define HOR_GLOBAL_READ_FAILED     100
#define HOR_GLOBAL_TALLOC_FAILED   101
#define HOR_GLOBAL_TALLOC_TOO_BIG  102
#define HOR_GLOBAL_TALLOC_OVERFLOW 103

/* maths library error codes */
#define HOR_MATH_MATRIX_SINGULAR           200
#define HOR_MATH_MATRIX_ILLEGAL_DIMENSIONS 201
#define HOR_MATH_MATRIX_INCOMPATIBLE       202
#define HOR_MATH_MATRIX_NOT_POS_DEFINITE   203
#define HOR_MATH_MATRIX_EXTRA_ZEROES       204
#define HOR_MATH_MATRIX_NOT_SQUARE         205
#define HOR_MATH_ILLEGAL_VALUE             206
#define HOR_MATH_NO_CONVERGENCE            207
#define HOR_MATH_NUMREC_BAD_PERMUTATION    208
#define HOR_MATH_ALLOCATION_FAILED         209
#define HOR_MATH_NULL_POINTER_ARGUMENT     210
#define HOR_MATH_LIMIT_EXCEEDED            211

/* list library error codes */
#define HOR_LIST_ASSOCIATION_NOT_FOUND 400

/* image library error codes */
#define HOR_IMAGE_CANNOT_READ_IMAGE_HEADER     500
#define HOR_IMAGE_ILLEGAL_IMAGE_TYPE_IN_HEADER 501
#define HOR_IMAGE_ILLEGAL_PIXEL_SCALE          502
#define HOR_IMAGE_ILLEGAL_BITS_PER_PIXEL       503
#define HOR_IMAGE_INVALID_IMAGE_REGION         504
#define HOR_IMAGE_IMAGE_TOO_SMALL              505
#define HOR_IMAGE_OPEN_FAILED_FOR_READ         506
#define HOR_IMAGE_OPEN_FAILED_FOR_WRITE        507
#define HOR_IMAGE_READ_FAILED                  508
#define HOR_IMAGE_WRITE_FAILED                 509
#define HOR_IMAGE_ALLOCATION_FAILED            510
#define HOR_IMAGE_NULL_POINTER_ARGUMENT        511
#define HOR_IMAGE_WRONG_TYPE_IMAGE             512
#define HOR_IMAGE_BAD_MAGIC_NUMBER             513

/* graphics library error codes */
#define HOR_GRAPHICS_DISPLAY_WINDOW_NOT_SET      600
#define HOR_GRAPHICS_CANVAS_NOT_INITIALIZED      601
#define HOR_GRAPHICS_ILLEGAL_SUBSAMPLING_RATIO   602
#define HOR_GRAPHICS_NON_EXISTENT_FONT_NAME      603
#define HOR_GRAPHICS_ILLEGAL_INTERNAL_DIMENSIONS 604
#define HOR_GRAPHICS_X_DISPLAY_FUNCTION_FAILED   605
#define HOR_GRAPHICS_INVALID_DISPLAY_DEPTH       606
#define HOR_GRAPHICS_COLOUR_NOT_ALLOCATED        607
#define HOR_GRAPHICS_NULL_POINTER_ARGUMENT       608
#define HOR_GRAPHICS_WRONG_TYPE_IMAGE            609
#define HOR_GRAPHICS_NON_EXISTENT_IMAGE          610
#define HOR_GRAPHICS_INCOMPATIBLE_IMAGE          611

/* improc library error codes */
#define HOR_IMPROC_REGION_TOO_SMALL        700
#define HOR_IMPROC_ILLEGAL_IMAGE_TYPE      701
#define HOR_IMPROC_ILLEGAL_CORNER_POSITION 702
#define HOR_IMPROC_ILLEGAL_PARAMETERS      703
#define HOR_IMPROC_IMAGES_INCOMPATIBLE     704
#define HOR_IMPROC_NULL_POINTER_ARGUMENT   705
#define HOR_IMPROC_OPEN_FAILED_FOR_READ    706
#define HOR_IMPROC_OPEN_FAILED_FOR_WRITE   707
#define HOR_IMPROC_READ_FAILED             708
#define HOR_IMPROC_ALLOCATION_FAILED       709

/* process library error codes */
#define HOR_PROCESS_UNDEFINED_RESULT_TYPE         800
#define HOR_PROCESS_UNDEFINED_PROCESS             801
#define HOR_PROCESS_UNDEFINED_PROCESS_TYPE        802
#define HOR_PROCESS_INCOMPATIBLE_RESULT_TYPES     803
#define HOR_PROCESS_DIFFERENT_LENGTH_RESULT_LISTS 804
#define HOR_PROCESS_DUPLICATED_RESULT_TYPES       805
#define HOR_PROCESS_DUPLICATED_PROCESS_TYPES      806
#define HOR_PROCESS_ILLEGAL_PROCESS_DATA          807
#define HOR_PROCESS_ILLEGAL_OUTPUT_DATA           808
#define HOR_PROCESS_IMAGES_INCOMPATIBLE           809
#define HOR_PROCESS_NULL_POINTER_ARGUMENT         810

/* tool library error codes */
#define HOR_TOOL_POPUP_PANEL_NOT_IN_USE     900
#define HOR_TOOL_POPUP_PANEL_ALREADY_IN_USE 901
#define HOR_TOOL_POPUP_PANEL_NOT_REGISTERED 902
#define HOR_TOOL_POPUP_PANEL_NOT_INIT       903
#define HOR_TOOL_GRAPH_NEGATIVE_TIME_RANGE  904
#define HOR_TOOL_GRAPH_NEGATIVE_F_RANGE     905
#define HOR_TOOL_GRAPH_ALREADY_SET_UP       906
#define HOR_TOOL_GRAPH_NOT_SET_UP           907
#define HOR_TOOL_GRAPH_TIME_REVERSAL        908
#define HOR_TOOL_GRAPH_NO_POINTS            909
#define HOR_TOOL_OPEN_FAILED_FOR_WRITE      910
#define HOR_TOOL_3D_ITEM_NOT_FOUND          911
#define HOR_TOOL_ALLOCATION_FAILED          912

extern int hor_errno;

void hor_perror ( const char *s );
