/*
 *Header:
 *File: utility.h (for C++ & cc)
 *Author: Noda Itsuki
 *Date: 1995/02/24
 *EndHeader:
 */

/*
 *ModifyHistory
 *
 *EndModifyHistory
 */

#define EPS 1.0e-10
#define IINFINITE 1.0e10	
#define PI 3.1415926535
#define mmax(x,y) ( ((x) > (y)) ? (x) : (y) )
#define mmin(x,y) ( ((x) > (y)) ? (y) : (x) )
#define Abs(x)	(((x) > 0.0) ? (x) : (-(x)) ) 
#define Atan(y,x) (((x==0.0) && (y==0.0)) ? (0.0) : atan2((y),(x)))
#define RAD2DEG	(180.0/PI)
#define DEG2RAD (PI/180.0)

#define Rad2Deg(a) 	((double)(a) * RAD2DEG)
#define Rad2IDeg(a)	(int)(Rad2Deg(a))
#define Deg2Rad(a)	((double)(a) * DEG2RAD)

#define Quantize(v,q)	((((v)/(q)))*(q))

#define Pow(x)	((x)*(x))

#define RANDOMBASE		1000
#define IRANDOMBASE		31

#define drand(h,l)	(((((h)-(l)) * ((double)(rand()%RANDOMBASE) / (double)RANDOMBASE))) + (l))
#define	irand(x)	((rand() / IRANDOMBASE) % (x))

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned int randomize(void) ;
/*
extern double drand(double l, double h) ;
*/
extern double normalize_angle(double ang) ;
#ifdef __cplusplus
} 
#endif

#ifdef X11R5
# define mySetArg_1st(slot,val)	XtSetArg(Args[0], slot, (val)); Argn = 1
# define mySetArg(slot,val)	XtSetArg(Args[Argn], slot, (val)); Argn++
#endif
